Windows Preview Handlers
========================

Since Vista, Windows includes a standard framework for displaying previews for any file type. This means any software vendor can create a preview of any file type — and allow any _other_ software to display a preview for their files. Microsoft Office provides several preview handlers by default, for the Office document formats.
You can find and install other Windows preview handlers online.

For example, if you install the free [PDF Xchange Reader](http://www.tracker-software.com/product/pdf-xchange-viewer), it installs a preview handler for PDF files. [ZPreview](../readme.md) will then display PDFs as well. (Even if you don't use PDF Xchange otherwise, or have associated PDF files with another program, [like Nitro PDF](https://www.gonitro.com/pdf-reader)).

Here are some other free preview handler packs:

* [https://previewhandlers.codeplex.com/](https://previewhandlers.codeplex.com/) - various source code files with syntax highlighting
* [http://code.google.com/p/delphi-preview-handler/](http://code.google.com/p/delphi-preview-handler/) - some more source code files with syntax highlighting

Since it's possible to have multiple preview handlers for the same file type, but only one associated with it, Stephen Toub has written a [Preview Handler Association Editor](http://blogs.msdn.com/b/toub/archive/2006/12/14/preview-handler-association-editor.aspx), which lets you choose. It also provides an overview of all installed Preview Handlers.
Since version 1.2, ZPreview allows you to use any preview handler installed on the system, and switch between them at will.

Technical documentation
-----------------------
* [Preview Handlers and Shell Preview Host](https://msdn.microsoft.com/en-us/library/windows/desktop/cc144143.aspx) by Microsoft
* [Hosting Preview Handlers in Delphi VCL Applications](https://theroadtodelphi.wordpress.com/2013/05/24/hosting-preview-handlers-in-delphi-vcl-applications/) by Rodrigo Ruz
* [Delphi Preview Handler](http://code.google.com/p/delphi-preview-handler/) by Rodrigo Ruz
* [Windows 7 Previews – the Delphi Way](http://www.uweraabe.de/Blog/2011/06/01/windows-7-previews-the-delphi-way/) by Uwe Raabe
